GET /v1/topics/{id}/versions
from metadata.generated.schema.entity.services.connections.metadata.openMetadataConnection import (
AuthProvider,
OpenMetadataConnection,
)
from metadata.generated.schema.security.client.openMetadataJWTClientConfig import (
OpenMetadataJWTClientConfig,
)
from metadata.ingestion.ometa.ometa_api import OpenMetadata
from metadata.generated.schema.entity.data.topic import Topic
metadata = OpenMetadata(
OpenMetadataConnection(
hostPort="https://your-company.open-metadata.org/api",
authProvider=AuthProvider.openmetadata,
securityConfig=OpenMetadataJWTClientConfig(jwtToken="your-jwt-token"),
)
)
# List all versions
history = metadata.list_versions(
entity_id="0a021819-982e-4ee4-a5a2-4af30eaa3016",
entity=Topic
)
for v in history.versions:
topic_version = Topic.model_validate_json(v)
print(f"Version {topic_version.version.root}: {topic_version.description.root}")
# Get a specific version
topic_v1 = metadata.get_entity_version(
entity=Topic,
entity_id="0a021819-982e-4ee4-a5a2-4af30eaa3016",
version="0.1"
)
print(f"Original description: {topic_v1.description.root}")
import org.openmetadata.schema.entity.data.Topic;
import org.openmetadata.schema.type.EntityHistory;
// client is an initialized OpenMetadataClient.
// List all versions
EntityHistory history = client.topics().getVersionList("0a021819-982e-4ee4-a5a2-4af30eaa3016");
for (Object version : history.getVersions()) {
System.out.println("Version: " + version);
}
// Get a specific version
Topic v1 = client.topics().getVersion("0a021819-982e-4ee4-a5a2-4af30eaa3016", 0.1);
System.out.println("Description: " + v1.getDescription());
# List all versions
curl "{base_url}/api/v1/topics/0a021819-982e-4ee4-a5a2-4af30eaa3016/versions" \
-H "Authorization: Bearer {access_token}"
# Get a specific version
curl "{base_url}/api/v1/topics/0a021819-982e-4ee4-a5a2-4af30eaa3016/versions/0.1" \
-H "Authorization: Bearer {access_token}"
{
"entityType": "topic",
"versions": [
"{\"id\":\"0a021819-982e-4ee4-a5a2-4af30eaa3016\",\"name\":\"address_book\",\"fullyQualifiedName\":\"sample_kafka.address_book\",\"version\":0.2,\"description\":\"Updated: All Protobuf record events captured with enhanced schema\",\"serviceType\":\"Kafka\"}",
"{\"id\":\"0a021819-982e-4ee4-a5a2-4af30eaa3016\",\"name\":\"address_book\",\"fullyQualifiedName\":\"sample_kafka.address_book\",\"version\":0.1,\"description\":\"All Protobuf record related events gets captured in this topic\",\"serviceType\":\"Kafka\"}"
]
}
Topic Versions
List and retrieve historical versions of a topic
GET
/
v1
/
topics
/
{id}
/
versions
GET /v1/topics/{id}/versions
from metadata.generated.schema.entity.services.connections.metadata.openMetadataConnection import (
AuthProvider,
OpenMetadataConnection,
)
from metadata.generated.schema.security.client.openMetadataJWTClientConfig import (
OpenMetadataJWTClientConfig,
)
from metadata.ingestion.ometa.ometa_api import OpenMetadata
from metadata.generated.schema.entity.data.topic import Topic
metadata = OpenMetadata(
OpenMetadataConnection(
hostPort="https://your-company.open-metadata.org/api",
authProvider=AuthProvider.openmetadata,
securityConfig=OpenMetadataJWTClientConfig(jwtToken="your-jwt-token"),
)
)
# List all versions
history = metadata.list_versions(
entity_id="0a021819-982e-4ee4-a5a2-4af30eaa3016",
entity=Topic
)
for v in history.versions:
topic_version = Topic.model_validate_json(v)
print(f"Version {topic_version.version.root}: {topic_version.description.root}")
# Get a specific version
topic_v1 = metadata.get_entity_version(
entity=Topic,
entity_id="0a021819-982e-4ee4-a5a2-4af30eaa3016",
version="0.1"
)
print(f"Original description: {topic_v1.description.root}")
import org.openmetadata.schema.entity.data.Topic;
import org.openmetadata.schema.type.EntityHistory;
// client is an initialized OpenMetadataClient.
// List all versions
EntityHistory history = client.topics().getVersionList("0a021819-982e-4ee4-a5a2-4af30eaa3016");
for (Object version : history.getVersions()) {
System.out.println("Version: " + version);
}
// Get a specific version
Topic v1 = client.topics().getVersion("0a021819-982e-4ee4-a5a2-4af30eaa3016", 0.1);
System.out.println("Description: " + v1.getDescription());
# List all versions
curl "{base_url}/api/v1/topics/0a021819-982e-4ee4-a5a2-4af30eaa3016/versions" \
-H "Authorization: Bearer {access_token}"
# Get a specific version
curl "{base_url}/api/v1/topics/0a021819-982e-4ee4-a5a2-4af30eaa3016/versions/0.1" \
-H "Authorization: Bearer {access_token}"
{
"entityType": "topic",
"versions": [
"{\"id\":\"0a021819-982e-4ee4-a5a2-4af30eaa3016\",\"name\":\"address_book\",\"fullyQualifiedName\":\"sample_kafka.address_book\",\"version\":0.2,\"description\":\"Updated: All Protobuf record events captured with enhanced schema\",\"serviceType\":\"Kafka\"}",
"{\"id\":\"0a021819-982e-4ee4-a5a2-4af30eaa3016\",\"name\":\"address_book\",\"fullyQualifiedName\":\"sample_kafka.address_book\",\"version\":0.1,\"description\":\"All Protobuf record related events gets captured in this topic\",\"serviceType\":\"Kafka\"}"
]
}
Topic Versions
Every change to a topic entity creates a new version. Use these endpoints to view the version history and retrieve specific versions.List Versions
string
required
UUID of the topic.
Get Specific Version
UseGET /v1/topics/{id}/versions/{version} to retrieve a specific version.
string
required
UUID of the topic.
string
required
Version number to retrieve, for example
0.2.GET /v1/topics/{id}/versions
from metadata.generated.schema.entity.services.connections.metadata.openMetadataConnection import (
AuthProvider,
OpenMetadataConnection,
)
from metadata.generated.schema.security.client.openMetadataJWTClientConfig import (
OpenMetadataJWTClientConfig,
)
from metadata.ingestion.ometa.ometa_api import OpenMetadata
from metadata.generated.schema.entity.data.topic import Topic
metadata = OpenMetadata(
OpenMetadataConnection(
hostPort="https://your-company.open-metadata.org/api",
authProvider=AuthProvider.openmetadata,
securityConfig=OpenMetadataJWTClientConfig(jwtToken="your-jwt-token"),
)
)
# List all versions
history = metadata.list_versions(
entity_id="0a021819-982e-4ee4-a5a2-4af30eaa3016",
entity=Topic
)
for v in history.versions:
topic_version = Topic.model_validate_json(v)
print(f"Version {topic_version.version.root}: {topic_version.description.root}")
# Get a specific version
topic_v1 = metadata.get_entity_version(
entity=Topic,
entity_id="0a021819-982e-4ee4-a5a2-4af30eaa3016",
version="0.1"
)
print(f"Original description: {topic_v1.description.root}")
import org.openmetadata.schema.entity.data.Topic;
import org.openmetadata.schema.type.EntityHistory;
// client is an initialized OpenMetadataClient.
// List all versions
EntityHistory history = client.topics().getVersionList("0a021819-982e-4ee4-a5a2-4af30eaa3016");
for (Object version : history.getVersions()) {
System.out.println("Version: " + version);
}
// Get a specific version
Topic v1 = client.topics().getVersion("0a021819-982e-4ee4-a5a2-4af30eaa3016", 0.1);
System.out.println("Description: " + v1.getDescription());
# List all versions
curl "{base_url}/api/v1/topics/0a021819-982e-4ee4-a5a2-4af30eaa3016/versions" \
-H "Authorization: Bearer {access_token}"
# Get a specific version
curl "{base_url}/api/v1/topics/0a021819-982e-4ee4-a5a2-4af30eaa3016/versions/0.1" \
-H "Authorization: Bearer {access_token}"
{
"entityType": "topic",
"versions": [
"{\"id\":\"0a021819-982e-4ee4-a5a2-4af30eaa3016\",\"name\":\"address_book\",\"fullyQualifiedName\":\"sample_kafka.address_book\",\"version\":0.2,\"description\":\"Updated: All Protobuf record events captured with enhanced schema\",\"serviceType\":\"Kafka\"}",
"{\"id\":\"0a021819-982e-4ee4-a5a2-4af30eaa3016\",\"name\":\"address_book\",\"fullyQualifiedName\":\"sample_kafka.address_book\",\"version\":0.1,\"description\":\"All Protobuf record related events gets captured in this topic\",\"serviceType\":\"Kafka\"}"
]
}
Returns
List versions returns an object withentityType and a versions array of serialized entity snapshots (newest first).
Get specific version returns the full topic object as it existed at that version.
Error Handling
| Code | Error Type | Description |
|---|---|---|
401 | UNAUTHORIZED | Invalid or missing authentication token |
404 | NOT_FOUND | Topic or version does not exist |
Was this page helpful?